unit Unit1;

{$mode objfpc}{$H+}

interface

uses
  Classes, SysUtils, FileUtil, OpenGLContext, Forms, Controls, Graphics, GraphType,
  Dialogs, ExtCtrls;

type

  { TForm1 }

  TForm1 = class(TForm)
    Image1: TImage;
    Timer1: TTimer;
    procedure FormCreate(Sender: TObject);
    procedure Image1Click(Sender: TObject);
    procedure Timer1Timer(Sender: TObject);
  private
  public

  end;

var
  Form1: TForm1;

implementation

{$R *.lfm}

{ TForm1 }


procedure TForm1.FormCreate(Sender: TObject);
var
  ABitmap: TBitmap;
  x, y: integer;

  function GetPixel(x, y: UInt32): boolean;
  var
    p: pUInt32;
  begin
    p := pUInt32(Image1.Picture.Bitmap.RawImage.Data);
    Inc(p, x + y * Image1.Picture.Bitmap.RawImage.Description.Width);
    Result := (p^ and $FF000000) <> 0;
  end;

  procedure SetPixel(x, y: UInt32);
  var
    ofs: UInt32;
    p: PByte;
    bit: byte;
  begin
    ofs := x + y * ABitmap.RawImage.Description.Width;
    ofs := ofs div 8;
    bit := x mod 8;
    p := ABitmap.RawImage.Data;
    Inc(p, ofs);
    p^ := p^ or (1 shl bit);
  end;

begin
  Image1.Picture.Bitmap.Width := Image1.Picture.Bitmap.Width div 8 * 8;
  Width := Image1.Picture.Bitmap.Width;
  Height := Image1.Picture.Bitmap.Height;

  if Image1.Picture.Bitmap.PixelFormat <> pf32bit then begin
    Exit;
  end;
  BorderStyle := bsNone;
  Self.Handle;

  ABitmap := TBitmap.Create;
  ABitmap.Monochrome := True;
  ABitmap.Width := Width;
  ABitmap.Height := Height;
//  ShowMessage(IntToStr(ABitmap.Width));

  if ABitmap.PixelFormat <> pf1bit then begin
 //   ShowMessage('gvdfgfg');
    Exit;
  end;

  with Image1.Picture.Bitmap do begin
    for x := 0 to Width - 1 do begin
      for y := 0 to Height - 1 do begin
        if GetPixel(x, y) then begin
          SetPixel(x, y);
        end;
      end;
    end;
  end;

  SetShape(ABitmap);
  ABitmap.FreeImage;
end;

procedure TForm1.Image1Click(Sender: TObject);
begin
  Close;
end;

procedure TForm1.Timer1Timer(Sender: TObject);
const
  i: integer = 0;
begin
  Inc(i);
  if i >= 500 then begin
    i := 0;
  end;
  Left := i;
  Top := i;
end;

end.
